# 
# @(#) $Id: psa.py,v 1.2 2001/09/10 15:47:09 ivm Exp $
#
# $Log: psa.py,v $
# Revision 1.2  2001/09/10 15:47:09  ivm
# Use "fundamental block size" rather than "preferred" in PSA
# free space calculations
#
# Revision 1.1  2000/08/14 16:02:01  ivm
# Initial versions
#
#

from txns import *
import os
try:	import statfs
except: pass

def free_MB(path):
	try:	
		tup = os.statvfs(path)
		return int(float(tup[1])*float(tup[4])/(1024*1024))
	except: 
		return statfs.free_mb(path)
	



class	PSA(HasTxns):
	def __init__(self, name, root):
		self.Name = name
		self.Root = root
		HasTxns.__init__(self, max, 0)

	def free(self): 	# calculate actual physical space available
		return free_MB(self.Root) - self.reservedByTxns()
		
	def freeMB(self):
		return free_MB(self.Root)
