#!/usr/bin/env python

import sys, os, string, traceback, re

UPS_PROD_NAME = os.environ.get('UPS_PROD_NAME', 'jim_config')
UPS_PROD_DIR = os.environ.get('UPS_PROD_DIR')
UPS_PROD_VERSION = os.environ.get('UPS_PROD_VERSION')
JIM_UPS_DB = os.environ.get('JIM_UPS_DB', '.')


#if not UPS_PROD_NAME:
#   UPS_PROD_NAME='jim_config'

SYMLINKS_DIR = JIM_UPS_DB + '/' + UPS_PROD_NAME + '/Symlinks'

def usage():
   print "%s <package name> [mode]"
   return 1
# usage


def removeLink(link):
   link = re.compile('//+').sub('/', SYMLINKS_DIR+'/'+link)
   try:
      print 'Deleting link', link
#      if os.path.exists(link):
      os.unlink(link)
   #except IOError:
   #except OSError:
   except:
      print >> sys.stderr, 'INFO: Cannot delete link', link
      #print >> sys.stderr, '---------------------------------------------'
      #traceback.print_exc()
      #print >> sys.stderr, '---------------------------------------------'
# removeLink


def removeChainLink(chain):
   removeLink(chain)
# removeChainLink


def removeVersionLink():
   removeLink(UPS_PROD_VERSION)
# removeVersionLink
 

def makeLink(path, link):
   removeLink(link)
   link = re.compile('//+').sub('/', SYMLINKS_DIR+'/'+link)
   print 'Creating link', link,'-->', path
   os.system('ln -s ' + path + ' ' + link )
# makeLink


def makeVersionLink(): 
   makeLink(UPS_PROD_DIR, UPS_PROD_VERSION)
# makeVersionLink
 
 
def makeChainLink(chain):
   makeVersionLink()
   makeLink(UPS_PROD_VERSION, chain)
# makeChainLink
 

def testSymlink(link):
   link = re.compile('//+').sub('/', SYMLINKS_DIR+'/'+link)
   if not os.path.exists(link):
      print >> sys.stderr, 'ERROR: Could not make link',link
# testSymlink
 

def main(argv):
   if (len(argv) < 1) or (len(argv) > 2):
       return usage()

   try:
      action = string.lower(argv[1])
   except:
      return usage()

   os.system('mkdir -p ' + SYMLINKS_DIR)  

   if action == 'configure':
      print 'Creating version link in', SYMLINKS_DIR,\
            'for', UPS_PROD_NAME, UPS_PROD_VERSION
      makeVersionLink()
      testSymlink(UPS_PROD_VERSION)
   elif action == 'unconfigure':
      print 'Removing version link in', SYMLINKS_DIR,\
            'for', UPS_PROD_NAME, UPS_PROD_VERSION
      removeVersionLink()
   elif action.startswith('un'):
      chain = action.replace('un','',1)
      print 'Removing', chain, 'link in', SYMLINKS_DIR,\
            'for', UPS_PROD_NAME, UPS_PROD_VERSION
      removeChainLink(chain)
   else:
      chain = action
      print 'Creating chain link in', SYMLINKS_DIR,\
            'for', UPS_PROD_NAME, UPS_PROD_VERSION
      makeChainLink(chain)
      testSymlink(action)

   return 0
# main


if __name__ == "__main__":
   sys.exit(main(sys.argv))
