#!/usr/bin/env python

import sys, traceback
from JimConfigManager import JimConfigManager 

def usage():
   print "%s <constants_file> [mode]"
   return 1

def main(argv):

   if (len(argv) < 2) or (len(argv) > 3):
       return usage()

   import os

   constants_file = argv[1]

   try:
      mode = argv[2]
   except:
      mode = 'DBFS'

   prdName = 'jim_config'
 
   try:
      jim_config_man = JimConfigManager.JimConfigManager(prdName)
      jim_config_man.setMode(mode)
      jim_config_man.storeGlobalConfigFile(constants_file)
   except:
      if jim_config_man.getDebugMode(): traceback.print_exc()
      print 'ERROR - Global configuration could not be stored successfully\n'
      return 1

   return 0

if __name__ == "__main__":
   sys.exit(main(sys.argv))
