"""
This python library makes managing the global configuration easy
"""

__author__="Parag Mhashilkar <parag@fnal.gov>"
__date__= "May 03 2003"
__version__="1.0"

# $source: GlobalConfigManager.py,v$

################################################################################
# Project   : SAM
# Package : jim_config
#
# This work is part of a development project, called JIM, which consists of a
# number of coordinated packages each named jim_xxxx .
#
# Notice of authorship, copyright status,  and terms and conditions, should
# the software eventually become available for use outside Fermilab, can be
# found in the README and LICENCE files in the top level directory of the main
# sam package.
################################################################################

import os, string, sys
import xml_common_lib
from BaseDBConfigManager import BaseDBConfigManager
from BaseFSConfigManager import BaseFSConfigManager


#####################################################################################
# Class: GlobalDBConfigManager
#####################################################################################
 

class GlobalDBConfigManager(BaseDBConfigManager):
   """This utility class manages the configuration storing and retrival from Db"""

   def __init__(self, name='global', version=None, qual=None):
      """
         Contructor to create a GlobalDBConfigManager

         name - Name of the package
      """

      name = 'global'
      BaseDBConfigManager.__init__(self, name)

      self.context = self.getGlobalContext()
      self.configDoc = self.getGlobalConfigDocName()
      self.printConfigDetails()
   # __init__


# Class GlobalDBConfigManager


#####################################################################################
# Class: GlobalFSConfigManager
#####################################################################################
 

class GlobalFSConfigManager(BaseFSConfigManager):
   """This utility class manages the configuration storing and retrival from Db"""

   def __init__(self, name='global', version=None, qual=None):
      """
         Contructor to create a GlobalFSConfigManager

         name - Name of the package
      """

      name = 'global'
      BaseFSConfigManager.__init__(self, name)

      self.path = self.getGlobalPath()
      self.configDoc = self.getGlobalConfigDocName()
      self.printConfigDetails()
   # __init__


# Class GlobalFSConfigManager
