#!/bin/bash
# script to find the sam_grid pid
# and echo it to the screen.
# Note that if there are more then
# one daemon running, all the pids
# will be printed out.
# This script comes from the
# sam_bbftp product... modified.

port=${1:-""}

# handle OS differences
PS_COMMAND="ps -u $USER -o pid,ppid,args"
case `uname -s` in
IRIX* )
  PS_COMMAND="ps -u $USER -o pid,ppid,args"
  ;;
Sun* )
  PS_COMMAND="ps -u $USER -o pid,ppid,args"
  ;;
Linux* )
  PS_PERSONALITY="sun"; export PS_PERSONALITY
  PS_COMMAND="ps -au `whoami` -o pid,ppid,args"
esac
pid=`eval "${PS_COMMAND}" | grep "ftpd: accepting connections on port $port" | grep -v grep | awk '{print $1}'`
if [ "x$pid" = "x" ]; then
  pid=`eval "${PS_COMMAND}" | grep "in.ftpd" | grep -v grep | awk '{print $1}'`
fi
echo ${pid}

