#!/bin/bash
#
# wrapper script to stop sam_gridftp.
# tries to kill all the daemons.

prog=`basename $0`
die () { echo "$prog: $*" >&2; exit 1; }

#get the server type
server_type=`echo $1|cut -f2 -d'=' `
[ -n "$server_type" ] || die "needs to know server_type"

# read the port number from the configuration
host=`hostname -f`
port=`jim_config_manager_cmd.py gca -n jim_gridftp -p\
 "/jim_gridftp_configuration/host[@name=\"${host}\"]/${server_type}/port" -a number`

[ -n "$port" ] || die "could not determine port for $server_type .. check jim_gridftp configuration"

echo "$prog: stopping $server_type running on port $port"

pid=`${JIM_GRIDFTP_DIR}/ups/echo_jim_gridftp_pid.sh $port`
if [ -z "${pid}" ]; then
  echo "No gridftp daemon listening to port $port is running."
else
  echo "killing in.ftpd process id ${pid} listening on port $port"
  kill ${pid}
  sleep 1
  kill -9 ${pid} 2> /dev/null
fi
