#!/usr/bin/env sampy

# for web development:
#  make sure that when running under my web
#   development pages, we put my python modules
#   earlier in the path.

import os
import sys
import string
import traceback

lauriRoot = "/home/lauri/webdevl/d0db-dev/html"
try:
    docRoot = os.environ["DOCUMENT_ROOT"]
    #special consideration for NUMI, running on an AFS web server,
    # where products are not setup in the initial environment.
    #  code contribued by Liz Buckley-Geer
    if string.find(docRoot, 'numi') != -1:
        sys.path.insert(0, '/afs/fnal/ups/ups/v4_7_2/SunOS+5/ups')
        os.environ['SETUPS_DIR'] = '/afs/fnal/ups/etc'
        from ups import getUps
        ups = getUps()
        ups.setup('sam')  #('-q GCC-3.3.1-PYTHON-2.1 -f SunOS+5.9 omniORB, sam_admin_pyapi')
except KeyError:
    docRoot = ""

global WE_ARE_DEVELOPING
if ( docRoot == lauriRoot ):
    WE_ARE_DEVELOPING = 1
    #
    # setup my environment of SAM things.
    #
    os.environ['SETUPS_DIR'] = "/usr/local/etc"
    sys.path.insert(0, "%s/ups" % os.environ['UPS_DIR'])
    from ups import getUps
    ups = getUps()

    productsToSetup = ['sam']
    setupStringList = []
    for p in productsToSetup:
        setupStringList.append('-r /home/lauri/vcvs/%s %s' % (p,p))
    setupString = string.join(setupStringList, ', ')
    ups.setup(setupString)

    os.environ["ORACLE_SID"] = "d0ofdev1"
    os.environ["SAM_DB_SERVER_NAME"] = "SAMDbServer.user_dev2:SAMDbServer"
else:
    WE_ARE_DEVELOPING = 0


import cgi
import AutoRegister
#================================================================================


if ( __name__ == "__main__" ):

    print 'Content-type: text/html'     # html is following
    print ''                            # blank line, end of headers
    print('<head><title>sam auto registration form</title></head>')
    print('<body bgcolor="ffff99">')

    AutoRegister.setDevelFlag(WE_ARE_DEVELOPING)

    try:
        if ( AutoRegister.initDb() ):

            form = cgi.FieldStorage()
            formOk = 0

            if ( len( form.keys() ) == 0 ):
                AutoRegister.showForm()
            else:
                AutoRegister.processForm(form)
        else:
            AutoRegister.processNoDb()
    except:
        print('<pre>')
        print('Exception: %s %s' % (sys.exc_info()[0], sys.exc_info()[1]))
        print('Now print stack dump:')
        try:
            for line in traceback.format_tb(sys.exc_info()[2]):
                print(string.strip(line))
            print('End of stack dump')
        except:
            print('EXCEPTION PRINTING DUMP: %s %s' % (sys.exc_info()[0], sys.exc_info()[1]))
        print('</pre>')
        
    print('</body>')
    print('</html>')
    
