#!/usr/bin/env sampy

# for web development:
#  make sure that when running under my web
#   development pages, we put my python modules
#   earlier in the path.

import os
import sys
import traceback
import string

lauriRoot = "/home/lauri/webdevl/d0db-dev/html"
try:
    docRoot = os.environ["DOCUMENT_ROOT"]
except KeyError:
    docRoot = ""

global WE_ARE_DEVELOPING
if ( docRoot == lauriRoot ):
    WE_ARE_DEVELOPING = 1
    os.environ["SAM_MIS_PYAPI_DIR"] = "/home/lauri/vcvs/sam_mis_pyapi"
    sys.path.insert(0, "/home/lauri/vcvs/sam_mis_pyapi/src")
    sys.path.insert(0, "/home/lauri/vcvs/sam_mis_pyapi/lib")
    sys.path.insert(0, "/home/lauri/vcvs/sam_common_pylib/")
else:
    WE_ARE_DEVELOPING = 0


import cgi
from SamBootstrapServerListFileHandler import SamBootstrapServerListFileHandler
DEFAULT_TAIL=100
#================================================================================

#################################################################################
# Return the name of the most-recently-modified file in the specified directory.
def getMostRecentModifiedFile(dir, prefix=''):
    try:
        file = string.strip(os.popen('ls -t %s/%s*' % (dir, prefix)).readlines()[0])
    except:
        print("EXCEPTION getting most recent modified file '%s': %s %s" % (dir, sys.exc_info()[0], sys.exc_info()[1]))
        file = None
    return file
#################################################################################


if ( __name__ == "__main__" ):

    print 'Content-type: text/html'     # html is following
    print ''                            # blank line, end of headers
    form = cgi.FieldStorage()

    # defaults:
    serverLogDir = None
    serverLogPrefix = ''
    tail = DEFAULT_TAIL

    inputValues = form.keys()
    def usage():
        title = "tailServerLog"
        output = """
        This script accepts 3 input parameters: serverLogDir, serverLogPrefix, and tail
        where:
            serverLogDir = path (local to the node running the web server) to the
                           server's logFile directory -- REQUIRED
            serverLogPrefix = prefix (first N characters) of the server log output file
                              (e.g., 'dbg' for dbservers, 'opt' for optimizers) -- OPTIONAL (default:'')
            tail = integer number of lines to pass to the tail command. -- OPTIONAL (default: 100)

        Example URLs would be:

         http://d0db-dev.fnal.gov/sam_mis_pyapi/cgi/tailServerLog?serverLogDir=/home/sam/private/dbserver__d0ora1__user_dev&serverLogPrefix=dbg
         http://d0db.fnal.gov/sam_mis_pyapi/cgi/tailServerLog?serverLogDir=/home/sam/private/optimizer__d0ora2__prd&serverLogPrefix=opt&tail=20
                 """
        return output

    def htmlify(line):
        """
        Change hypercharacters to something visible.
        """
        for (old,new) in ( ('&', '&amp;'),
                           ('<', '&lt;'),
                           ('>', '&gt;') ):
            line = string.replace(line, old, new)
        return line
    
    if not form.has_key('serverLogDir'):
        output = usage()
    else:
        serverLogDir = form['serverLogDir'].value
        if form.has_key('serverLogPrefix'): serverLogPrefix = form['serverLogPrefix'].value
        if form.has_key('tail'): tail = form['tail'].value
        try:
            logFile = getMostRecentModifiedFile(serverLogDir, serverLogPrefix)
            title = "tail -%s %s" % (tail, logFile)
            output = "$ %s\n" % title
            for line in os.popen("tail -%s %s" % (tail, logFile)).readlines():
                output += htmlify(line)
        except Exception, ex:
            title = "tail"
            output = "%s %s" % (sys.exc_info()[0], sys.exc_info()[1])
            for line in traceback.format_tb(sys.exc_info()[2]):
                output += "\n%s" % line

    if ( WE_ARE_DEVELOPING ):
        output = "<font color=red>DEVELOPMENT COPY IN USE!</font><br><br>" + str(output)


    print('<head><title>%s</title></head>' % title)
    print('<body bgcolor="#FFFF99">')
    print('<pre>')
    print('%s' % output)
    print('</pre>')
    print('</body>')
    print('</html>')
