#!/bin/env tcsh
setenv thisDir $PWD
setenv theProj `basename ${thisDir}`
setenv depend_file DEPENDENCIES

setenv productList ""
if ( -r ${depend_file} ) then
    setenv productList "${productList} `cat $depend_file`"
endif

echo "Setting up ${theProj} -q build from this directory..."
setup ${theProj} -P -r${thisDir} -Mups -Uups -m${theProj}.table -q build

foreach dep ( ${productList} )
    ups exist ${dep} -r ${thisDir}/../${dep} -P -Mups -Uups -m${dep}.table
    if ( $status == 0 ) then
	echo "Setting up ${dep} -j -q build..."
	setup ${dep} -j -r ${thisDir}/../${dep} -P -Mups -Uups -m${dep}.table -q build
    else
	ups exist ${dep}
	if ( $status == 0 ) then
		echo "Setting up INSTALLED ${dep} -q build..."
		setup ${dep} -j -q build
	else
		echo "Product not found: ${dep}"
	endif
    endif
end

unsetenv thisDir
unsetenv theProj
unsetenv depend_file
unsetenv productList
