#!/usr/bin/env sampy
import sys
import os
import string
import types
import imp

from SamCpFileParser import SamCpFileParser
from SamCpExceptions import SamCpMethodNotImplementedException, SamCpUnrecognizedProtocol


##########################################################################################################

class SamCpProtocolArbitrator:
    """
    Base class
    """
    def __init__(self, samCpCommand):
        self.configMgr = samCpCommand.getConfigMgr()
        self.curLoc    = samCpCommand.getCurLoc()
        self.srcLoc    = samCpCommand.getSrcLoc()
        self.destLoc   = samCpCommand.getDestLoc()
        self.debug     = samCpCommand.getDebug()
        self.dbgprint  = samCpCommand.getDbgprint()
        self.verbose   = samCpCommand.getVerbose()
        self.vsay      = samCpCommand.getVsay()

        self.protocol        = None
        self.copier          = None
    ######################################################################################
    def setProtocol(self, protocol): self.protocol = protocol
    def getProtocol(self): return self.protocol
    ######################################################################################
    def setCopier(self, copier): self.copier = copier
    def getCopier(self): return self.copier
    ######################################################################################
    def getSrcLoc(self): return self.srcLoc
    ######################################################################################
    def getDestLoc(self): return self.destLoc
    ######################################################################################
    def getVerboseFlag(self): return self.verbose
    ######################################################################################
    def getDebugFlag(self): return self.debug
    ######################################################################################
    def selectProtocol(self):
        # MUST BE OVERRIDDEN BY DERIVED CLASSES!
        raise SamCpMethodNotImplementedException()
##########################################################################################################
    
class SamCpDefaultProtocolArbitrator(SamCpProtocolArbitrator):
    def __init__(self, samCpCommand):
        SamCpProtocolArbitrator.__init__(self, samCpCommand)
    ######################################################################################
    def selectProtocol(self):
        preferredProtocolName = self.configMgr.getPreferredSamCpProtocolName()
        self.setProtocol( preferredProtocolName )
        return self.getProtocol()
    ######################################################################################
