#! /usr/bin/env python
import sys,os
from xml.sax import saxutils
from xml.sax import make_parser
import commands

def getstrTime():
   import time
   return time.strftime("%a %D %T",time.localtime())
InfoPfx  = "INFO   :"
ErrPfx  =  "ERROR  :"
WarnPfx =  "WARNING:"
def printInfo(stringToPrint):
   print >>sys.stdout, "sam_fcp.py: %s: %s %s" %(getstrTime(),InfoPfx,stringToPrint)
def printError(stringToPrint):
   print >>sys.stderr, "sam_fcp.py: %s: %s %s" %(getstrTime(),ErrPfx,stringToPrint) 
def printWarning(stringToPrint):
   print >>sys.stderr, "sam_fcp.py: %s: %s %s" %(getstrTime(),WarnPfx,stringToPrint)
   
def get_config(queue):
	sys.path.append(os.environ.get('SAM_FCP_DIR')+"/ups/")
	from parse import handler
	parser = make_parser()
	handle = handler(1,queue)
	parser.setContentHandler(handle)
	cmd = "jim_config_manager_cmd.py gcs -n sam_fcp -m FS"
	status,output = commands.getstatusoutput(cmd)
	if status != 0:
		printError("Could not read configuration for sam_fcp")
		printError(output)
		sys.exit(1)
	import cStringIO
	parser.parse(cStringIO.StringIO(output))
	file_array = handle.get_file_array()
	transfer_mech = handle.get_tranfer_mech()
	return file_array,transfer_mech


def main(args):
   # we donot process args in here.
   # UPDATE: We do process 1 argument here. The Queue argument
   # so that we get the 
   printInfo("args are %s"% args[1:])
   import getopt
   optlist,arg = getopt.getopt(args[1:],'q:')
   if optlist:
   	queue = optlist[0][1]
	args = args[3:]
   else:
   	queue = "default"

   if os.environ.get('SAM_FCP_QUEUE_NAME'):
	queue = os.environ.get('SAM_FCP_QUEUE_NAME')
   printInfo ("THE SAM_FCP_QUEUE_NAME env var is set to %s " % (queue) )
 
   file_array,commandToUse = get_config(queue)
   if file_array:
   	os.environ['FCP_CONFIG'] = file_array[0]
   else:
   	if not os.environ.has_key('FCP_CONFIG') :
      		printError("Cannot find fcp config fle FCP_CONFIG in the environment")
      		sys.exit(1)
   	else:
   		cmd="jim_config_manager_cmd.py gca -n sam_fcp -p \"/sam_fcp_configuration/transfer_mechanism\" -a name -m FS"
   		status,output = commands.getstatusoutput(cmd)
   		if status != 0 :
      			printError("Could not find fcp queue name "+queue+ " in the sam_fcp configuration or sam_fcp configuration is not found")
      			printError(output)
      			sys.exit(1)
    
   		commandToUse = output
   
   strargs = ""
   for a in args[1:] :
      strargs = "%s %s" %(strargs,a)
   
   
   # exec the command   
   cmd = "fcp -c %s %s" %(commandToUse,strargs) 
   printInfo("Executing command %s" % (cmd) )

   status,output = commands.getstatusoutput(cmd)
   status = status / 256
   
   printInfo("Command exited with status %d" % status)
   printInfo("stdout & stderr of command: ")
   print output
   print "\n\n"
   if ( file_array ):
      os.system("rm -rf "+file_array[0])
   sys.exit(status) 
   
   

if __name__ == '__main__':
   sys.exit(main(sys.argv))
