import sys,os
from xml.sax import saxutils
from xml.sax import make_parser


class handler(saxutils.DefaultHandler):
	def __init__(self,search_flag=0,queue=""):
		self.queue_name=queue
		self.transfer_mech=""
		self.port_num=0
		self.transfer=0      #number of parallel transfers
		self.search_flag=search_flag
		self.found = 0
		self.stop_processing = 0
		self.file_array=[]
		if self.search_flag == 1 and not self.queue_name:
			self.queue_name = "default"
		
	def startElement(self,name,attrs):
		if self.search_flag == 1:
			if ((name == "fcp_queue") and (attrs.get('name','') == self.queue_name) and self.found == 0):
				self.found = 1
			if ((name == "fcp_port") and (self.found == 1)):
				self.port_num = int(attrs.get('port',''))
			if ((name == "max_xfers") and (self.found == 1)):
				self.transfer = int(attrs.get('transfers',''))
			if ((name == "transfer_mechanism") and (self.found == 1)):
				self.transfer_mech = attrs.get('name','')
			if ((name == "time_out") and (self.found == 1)):
				self.time_out = int(attrs.get('value',''))/60
		elif (self.search_flag == 0 and self.found == 0):
			if name == "fcp_queue":
				self.queue_name = attrs.get('name','')
			if name == "fcp_port":
				self.port_num = int(attrs.get('port',''))
                        if name == "max_xfers":
                                self.transfer = int(attrs.get('transfers',''))

			if name == "time_out":
				self.time_out = int(attrs.get('value',''))/60

	def endElement(self,name):
		if self.search_flag == 1:
			if ((name == "fcp_queue") and (self.found == 1)):
				self.file_array.append(self.create_config_file())
				self.search_flag = 0
			else:
				pass
		elif (self.search_flag == 0 and self.found == 0):
			if name == "fcp_queue":
				self.file_array.append(self.create_config_file())
	def create_config_file(self):
                import random
                import os
                TMPDIR = os.environ.get('TMPDIR',"/tmp")
                fname = TMPDIR+"/fcp_"+self.queue_name+"_"+str(random.randint(1,10000))+str(os.geteuid())+".cfg"

		try:
			if (os.environ.get('SAM_FCP_QUEUE_NAME')) and ( self.queue_name != os.environ.get('SAM_FCP_QUEUE_NAME')):
				print " ERROR: THE SAM_FCP_QUEUE_NAME var is set but its value is not supported in the sam_fcp config" + os.environ.get('SAM_FCP_QUEUE_NAME')
				print " Exiting now"
				sys.exit(1)
				
			f = open(fname,'w')
			config_string = "%%set fcp \nport = %d \nmax_xfers= %d \ntimeout = %d \nlog_file = %s\n" % (self.port_num,self.transfer,self.time_out,os.getcwd()+"/fcp_"+self.queue_name+".log")
			f.write(config_string)
			f.close()
		except Exception,ex:
			print "Problem creating config file " + fname + ":"+str(ex)
			sys.exit(1)
		return(fname)

	def get_file_array(self):
		return self.file_array
	def get_tranfer_mech(self):
		return self.transfer_mech
		
def main(args):
	#print args
	#f = open(sys.stdin,'r')
	parser = make_parser()
	handle = handler()
	parser.setContentHandler(handle)
	parser.parse(sys.stdin)
	file_array=handle.get_file_array()
	for i in file_array:
		print i
	
	return

if __name__ == "__main__":
	main(sys.argv)
	sys.exit(0)
