#!/bin/sh

prog=`basename $0`

echoInfo()    { echo "$prog: `date "+%a %D %T"`: INFO   : $*"; }
echoWarning() { echo "$prog: `date "+%a %D %T"`: WARNING: $*"; }
echoError()   { echo "$prog: `date "+%a %D %T"`: ERROR  : $*"; }
die (){ echoError "$*"; exit 1; }
remove_file () { chmod ug+w $1; rm -rf $1; }

killptree ()
{
   while [ -n "$1" ]; do
   root=$1
   if [ -z "${root}" ]; then
       echoError "Root of tree cannot be blank"
   else
      echoInfo "Killing process tree rooted at pid $root"
      #debug
      pids=`pstree -p $root | tr ')' '\012' | grep '(' | cut -f2 -d'('`
      echoInfo "Killing following pids"
      echoInfo $pids
      kill -9 `echo $pids`
   fi
   shift
   done
}

cmd="ps -au `whoami` | fgrep fcpd | grep -v fcpd.py | grep -v grep | awk '{print \$1}'"
pid=`eval $cmd`

if [ -z "$pid" ];then
   echoWarning "No fcp daemon running"
else
   echoInfo "Stopping fcp daemon"
   killptree $pid
   tmp_files=`ls $TMPDIR/fcp_*.cfg $TMPDIR/fcp_*.pid 2>/dev/null`
   echo "Removing temporary configuration and pid files"
   rm -rf $tmp_files
fi
