#############################################################################
# Project   : JIM
# Package : xml_common
# $Id: Xml2ObjectBuilder.py,v 1.3 2005/10/10 00:47:43 abaranov Exp $
#
# This work is part of a development project, called JIM, which consists of a
# number of coordinated packages each named jim_xxxx .
#
# Notice of authorship, copyright status,  and terms and conditions, should
# the software eventually become available for use outside Fermilab, can be
# found in the README and LICENCE files in the top level directory of the main
# sam package.
#############################################################################

import sys,os

from xml.sax import saxutils
from xml.sax import make_parser
from xml.sax.handler import feature_namespaces


class Base:
    def __init__(self):
        pass
    
class Xml2ObjectBuilder(saxutils.DefaultHandler):

    def __init__(self,fd, base = Base()):

        self._root = base
        self._stack = []

        import xml_common_lib.SaxParser
        xml_common_lib.SaxParser.SaxParser().parse(self,fd)

    def startElement(self, name, attrs):
        current = Base()

        import string
        ammendedName = string.replace(name,"-","_")

        try:
            getattr(self._root,ammendedName).append(current)
        except:
            setattr(self._root,ammendedName,[current])

        for (attrName,attrValue) in attrs.items():
            setattr(current,string.replace(attrName,"-","_"),attrValue)

        self._stack.append(self._root)
        self._root = current
        
    def endElement(self, name):

        self._root = self._stack.pop()

    def characters(self,content):
        try:
            getattr(self._root,"elementContentPyData").append(content)
        except:
            setattr(self._root,"elementContentPyData",content)
        
    def getRoot(self):
        return self._root
