#! /usr/bin/env python

################################################################################
# Project   : JIM
# Package : xmldb_client
#
# $Id: getXMLDBServerURL.py,v 1.13 2004/08/03 19:52:52 sankalp Exp $
#
#
# This work is part of a development project, called JIM, which consists of a
# number of coordinated packages each named jim_xxxx .
#
# Notice of authorship, copyright status,  and terms and conditions, should
# the software eventually become available for use outside Fermilab, can be
# found in the README and LICENCE files in the top level directory of the main
# sam package.
################################################################################

import sys

def main(args):
  
  TRUE  = 1
  FALSE = 0
  
  if len(args) < 2 :
    from os.path import basename
    print >>sys.stderr, "Usage: %s /path/to/config/dir/ [--not-verbose]" %  basename(args[0])
    print >>sys.stderr, "       Sensitive environment variables:"
    print >>sys.stderr, "          XMLDB_CLIENT_VERBOSITY = off"
    sys.exit(1)
    
  verboseFlag = TRUE 
  if ( args.count('--not-verbose') != 0 ):
    args.remove('--not-verbose')
    verboseFlag = FALSE
  else:
    try:
      import os
      verbosity = os.environ["XMLDB_CLIENT_VERBOSITY"]
      if verbosity == "off" or verbosity == "OFF":
        verboseFlag = FALSE
    except:
      pass
  
  configFile = args[1]
  from xml_common_lib.Xml2ObjectBuilder import Xml2ObjectBuilder

  try:
    f = open(configFile, 'rt')
    options = Xml2ObjectBuilder(f).getRoot()
    f.close()
  except:
    if verboseFlag == 1:
      print >>sys.stderr, "WARNING: YOU PROBABLY HAVE NOT TAILORED xmldb_client"
      print >>sys.stderr, "         As user product you should issue"
      print >>sys.stderr, "         > ups tailor xmldb_client"
      print >>sys.stderr, "         The JIM software suite will not work properly"
      print >>sys.stderr, "         without this step. The xml db client, though,"
      print >>sys.stderr, "         may still work by itself"
    sys.exit(1)

  try:
    serverURL = options.xmldb_client[0].xmldb_server[0].url
  except:
    if verboseFlag == 1:
      print >>sys.stderr, "WARNING: CANNOT READ DEFAULT xmldb_server URL"
      print >>sys.stderr, "         Possibly there was an error during the"
      print >>sys.stderr, "         tailoring of xmldb_client"
      print >>sys.stderr, "         As user product you should issue"
      print >>sys.stderr, "         > ups tailor xmldb_client"
      print >>sys.stderr, "         and reconfigure the client."
      print >>sys.stderr, "         After that, make sure you issue"
      print >>sys.stderr, "         > setup xmldb_client"
      print >>sys.stderr, "         from a \"clean\" shell environment."
    sys.exit(1)

  print serverURL

if __name__ == "__main__":
    sys.exit( main(sys.argv) )

